import { Component, OnInit, TemplateRef } from '@angular/core';
import { FormGroup, Validators, FormBuilder } from '@angular/forms';
import { BsModalRef, ModalOptions, BsModalService } from 'ngx-bootstrap';
import { Router } from '@angular/router';
import { CommondialogComponent } from '../../../app/Shared/commondialog/commondialog.component';
import { ToastrService } from 'ngx-toastr';
import { DialogService } from 'ng2-bootstrap-modal';
import { HeadingLevel } from './headinglevel';
import { HeadinglevelService } from './headinglevel.service';

@Component({
  selector: 'app-headinglevel',
  templateUrl: './headinglevel.component.html',
  styleUrls: ['./headinglevel.component.css']
})
export class HeadinglevelComponent implements OnInit {
  sendMenuId: number;
  sendPageName = 'HeadingLevel';
  // action rights
  _menuId: any;
  _actionRights: any;
  readOnly = false; add = false; edit = false; delete = false;
  headinglevelForm: FormGroup;
  headinglevels: HeadingLevel[] = [];
  headinglevelsactive: HeadingLevel[] = [];
  headinglevel: HeadingLevel;
  deleteResult: boolean;
  postresult: boolean;
  putDResult: boolean;
  headinglevelModalRef: BsModalRef;
  operation: string;
  userid: number;
  headinglevelid: number;
  submitted = false;
  active: number;
  unamePattern: string;
  confmsg: string;
  p = 1; searchText: string;
  itemsPerPage = 10;
  config: ModalOptions = {
    backdrop: 'static',
    keyboard: false,
    animated: true,
    class: 'modal-dialog-centered',
    ignoreBackdropClick: true
  };
  showall = true;
  showallstatus = false;
  key = 'headinglevel'; // set default
  reverse = false;
  actionRights: any;
  constructor(private router: Router, private toastr: ToastrService, private dialogService: DialogService,
    private formBuilder: FormBuilder, private modalService: BsModalService, private headinglevelservice: HeadinglevelService) 
    {
    // get rights for the logged in user for the particular component
    if (this.router.getCurrentNavigation().extras.state !== undefined) {
      localStorage.setItem('HeadingLevel_menuid', this.router.getCurrentNavigation().extras.state.menuid);
      localStorage.setItem('HeadingLevel_userRights', this.router.getCurrentNavigation().extras.state.action);
      this.actionRights = [];
      this.actionRights = this.router.getCurrentNavigation().extras.state.action;
    } else {
      this.actionRights = [];
      this.actionRights = localStorage.getItem('HeadingLevel_userRights');
    }
    
  }

  ngOnInit() {
    this.headinglevelForm = this.formBuilder.group({
      headinglevelid: [''],
      headinglevel: ['', [Validators.required]],
      active: ['']
    });
    this.searchText = '';
    this.getAll();
    // for action rights
    this.getUserRights();
  }

  getactiveinactive(showallp) {
    this.headinglevelsactive = [];
    this.showall = showallp;
    this.showallstatus = showallp;
    if (this.showall === true) {
      this.showall = false;
      this.headinglevels.forEach(data => {
        if (data.active === 1) {
          this.headinglevelsactive.push(data);
        }
      });
      this.headinglevels = [];
      this.headinglevels = this.headinglevelsactive;
    } else {
      this.showall = true;
      this.headinglevels = [];
      this.getAll();
    }
  }

  // function to get user rights
  getUserRights() {
    const btnToEnable = JSON.parse(this.actionRights);
    if (btnToEnable.length > 0) {
      this.readOnly = true;
      btnToEnable.forEach(d => {
        if (d !== undefined) {
          if (d === 2) {
            this.add = true;
          } else if (d === 3) {
            this.edit = true;
          } else if (d === 4) {
            this.delete = true;
          }
        }
      });
    }
  }

  clearForm() {
    this.headinglevelModalRef.hide();
  }

  sort(key) {
    this.key = key;
    this.reverse = !this.reverse;
  }


  getAll() {
    this.headinglevels = [];
    this.headinglevelsactive = [];
    this.headinglevelservice.Get().subscribe(res => {
      if (res[0] != null && res[0] !== undefined) {
        this.headinglevels = JSON.parse(res[0]);
        if (this.showallstatus === true) {
          this.headinglevels.forEach(data => {
            if (data.active === 1) {
              this.headinglevelsactive.push(data);
            }
          });
          this.headinglevels = [];
          this.headinglevels = this.headinglevelsactive;
        }
      }
    }, error => { this.toastr.error('Error while getting data'); });

  }

  get g() { return this.headinglevelForm.controls; }

  Post(headinglevel: HeadingLevel) {

    this.submitted = true;

    if ((headinglevel.headinglevel.trim() === undefined) || (headinglevel.headinglevel.trim() === '')) {
      this.toastr.error('HeadingLevel should not be empty');
      return;
    }

    let msg = null;

    this.userid = +localStorage.getItem('userid');
    headinglevel.headinglevel = headinglevel.headinglevel.trim();
    if (this.operation === 'add') {

      headinglevel.createdby = this.userid;
      msg = 'Record Added Successfully';
      this.headinglevelservice.Post(headinglevel).subscribe(res => {
        if (res.status === 200) {
          if (res !== undefined) {
            if (res.body !== 0) {
              this.headinglevelModalRef.hide();
              this.getAll();
              this.toastr.success('Data added successfully');
              this.clearForm();
            } else { this.toastr.warning('Record already exists.'); }
          }
        }
      },
        error => {
          this.toastr.error('Error while doing the operation');
          this.postresult = false;
        });
    } else if (this.operation = 'update') {
      headinglevel.updatedby = this.userid;
      msg = 'Record updated successfully';
      this.headinglevelservice.Put(headinglevel).subscribe(res => {
        if (res.status === 200) {
          if (res !== undefined) {
            if (res.body !== 0) {
              this.headinglevelModalRef.hide();
              this.getAll();
              this.toastr.success('Data updated successfully');
              this.clearForm();
            } else { this.toastr.warning('Record already exists.'); }
          }
        }
      },
        error => {
          this.toastr.error('Error while doing the operation');
          this.postresult = false;
        });
    }
    this.submitted = false;

  }

  ChangeActive(e) {
    if (e.currentTarget.checked) {
      this.headinglevelForm.controls['active'].setValue(1);
    } else {
      this.headinglevelForm.controls['active'].setValue(0);
    }
  }

  OpenConfirmTemplate(headinglevel) {
    if (headinglevel.active === 0) {
      this.confmsg = 'activate';
    } else {
      this.confmsg = 'deactivate';
    }
    this.dialogService.addDialog(CommondialogComponent,
      {
        title: 'Please Confirm',
        message: 'Are you sure you want to ' + this.confmsg + ' this record ?',
        hclass: 'modelsuccess',
        oktext: 'Yes',
        canceltext: 'No',
        okshow: true,
        cancelshow: true
      }).subscribe((isConfirmed) => {
        if (isConfirmed) {
          this.headinglevel = headinglevel;

          this.Delete();

        }

      });

  }

  Delete() {
    let msg;
    if (this.headinglevel.active === 0) {
      this.headinglevel.active = 1;
      msg = 'Record activated successfully';
    } else {
      this.headinglevel.active = 0;
      msg = 'Record deactivated successfully';
    }
    this.userid = +localStorage.getItem('userid');
    this.headinglevel.updatedby = this.userid;
    this.headinglevelservice.Delete(this.headinglevel).subscribe(res => {
      this.toastr.success(msg);
      this.getAll();
    },
      error => { this.deleteResult = false; });

  }

  hidePopup() {
    this.headinglevelModalRef.hide();
  }

  openHeadingLevelModal(template: TemplateRef<any>, type, headinglevel?: HeadingLevel) {

    this.operation = type;

    if (type === 'update') {
      this.headinglevelForm.controls['headinglevelid'].setValue(headinglevel.headinglevelid);
      this.headinglevelForm.controls['headinglevel'].setValue(headinglevel.headinglevel);
      this.headinglevelForm.controls['active'].setValue(headinglevel.active);
      this.headinglevel = headinglevel;
    }
    if (type === 'add') {
      this.headinglevelForm.controls['headinglevelid'].setValue(0);
      this.headinglevelForm.controls['headinglevel'].setValue('');
      this.headinglevelForm.controls['active'].setValue(1);
    }
    this.headinglevelModalRef = this.modalService.show(template, this.config);

    const aa = document.getElementsByClassName('modal-content');
    aa[0].classList.remove('modal-content');

  }

}
